<?php

namespace Drupal\Tests\fluent\Functional;

use Drupal\Core\Datetime\DrupalDateTime;

/**
 * Test basic functionality of My Module.
 *
 * @group fluent
 */
class SingleValueTestCase extends FluentTestBase {

  public function testBaseNodeField() {
    $node = $this->getNode();
    $title = $node->getTitle();

    $this->assertEquals($title, using($node)->value('title'));
    $this->assertEquals('en', using($node)->value('langcode'));

    $this->assertIsInt(using($node)->value('nid'));
    $this->assertIsString(using($node)->value('id'));
    $this->assertInstanceOf(DrupalDateTime::class, using($node)->value('changed'));
    $this->assertInstanceOf(DrupalDateTime::class, using($node)->value('created'));
  }

  public function testCreatedField() {
    $image = $this->getMediaImage();
    $timestamp = $image->getCreatedTime();
    $ddateTime = fluent()->using($image)->value('created');

    $this->assertInstanceOf(DrupalDateTime::class, $ddateTime);
    $this->assertEquals($ddateTime->getTimestamp(), $timestamp);
  }

  public function testTaxonomyTermField() {
    // @todo
  }

  /**
   * Test field_boolean_single
   */
  public function testFieldBooleanSingle(){
    $node = $this->getNode();
    $boolean_single = $node->get('field_boolean_single')->getString() === '1' ? true : false;

    $this->assertSame($boolean_single, using($node)->value('field_boolean_single'));
  }

  /**
   * Test field_color_single
   */
  public function testFieldColorSingle(){
    $node = $this->getNode();
    $color = $node->get('field_color_single')->getValue()[0]['color'];
    $opacity = (float)$node->get('field_color_single')->getValue()[0]['opacity'];

    $this->assertSame($color, using($node)->value('field_color_single.color'));
    $this->assertSame($opacity, using($node)->value('field_color_single.opacity'));
  }

}
